<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xmi="http://www.omg.org/XMI" xmlns:addon="http://org.bflow.addon" xmlns:epc="org.bflow.toolbox.epc" xmlns:notation="http://www.eclipse.org/gmf/runtime/1.0.2/notation" xmlns:msxsl="urn:schemas-microsoft-com:xslt">
  <xsl:output method="text" encoding="iso-8859-1"/>
  <xsl:template match="text()">
    <xsl:value-of select="normalize-space( )"/> <!-- leerzeichen entfernen -->
  </xsl:template>

  <xsl:key name="attr_id" match="//attributes" use="@id"/>
  <xsl:key name="name_key" match="//attributes" use="@name"/>
  <xsl:key name="el_id_key" match="//elements" use="@xmi:id"/>
  <xsl:key name="from" match="//connections" use="//connections/@from"/>
  <xsl:key name="to" match="//connections" use="@to"/>
  <xsl:key name="con_id" match="//connections" use="@xmi:id"/>
  <xsl:key name="in_key" match="//elements" use="@in"/>
  <xsl:key name="el_pos_key" match="//elements" use="position()"/>
  <xsl:key name="out_key" match="elements" use="@out"/>
  <xsl:param name="out_param" select="//elements/@out"/>
  <xsl:param name="in_param" select="//elements/@in"/>
  <xsl:param name="id_param" select="//elements/@xmi:id"/>
  <xsl:key name="val_key" match="attributes" use="@id"/>
  <xsl:key name="name_key" match="attributes" use="@name"/>
  <xsl:key name="out_key" match="elements" use="@out"/>
  <xsl:key name="in_key" match="elements" use="@in"/>
  <xsl:key name="pos_key" match="elements" use="position()"/>
  <xsl:variable name="cut" select="';'"/>
  <xsl:param name="name_array" select="/xmi:XMI/epc:Epc/elements/@name"/>
  <xsl:param name="attr1_array" select="//addon:AddonAttributes/attributes/@name"/>
  <xsl:param name="attr2_array" select="//addon:AddonAttributes/attributes/@value"/>
  <xsl:param name="id_array" select="/xmi:XMI/epc:Epc/elements/@xmi:id"/>
  <xsl:param name="out_array" select="/xmi:XMI/epc:Epc/elements/@out"/>
  <xsl:param name="attr_array" select="//addon:AddonAttributes/attributes/@value"/>
  <xsl:param name="attr_id_array" select="//addon:AddonAttributes/attributes/@id"/>
  <xsl:param name="name_param" select="/xmi:XMI/epc:Epc/elements/@name"/>
  <xsl:param name="id" select="/xmi:XMI/epc:Epc/elements/@xmi:id"/>
  <xsl:key  name="attr_id" match="//attributes" use="@id"/>
  <xsl:key name="name_key" match="//attributes" use="@name"/>
  <xsl:param name="from_param" select="/xmi:XMI/epc:Epc/connections/@from"/>
  <xsl:param name="to_param" select="/xmi:XMI/epc:Epc/connections/@to"/>
  <xsl:param name="con_id_param" select="/xmi:XMI/epc:Epc/connections/@xmi:id"/>
  <xsl:key name="from_key" match="//connections" use="@from"/>
  <xsl:key name="to_key" match="//connections" use="@to"/>
  
  <xsl:template match="/xmi:XMI/epc:Epc">
    <xsl:text>#;Prozessschritt;Dauer[Arbeitstage];;;Kosten;;;</xsl:text>
    <xsl:for-each select ="/xmi:XMI/epc:Epc/elements">
      <xsl:text>;</xsl:text>
      <xsl:value-of select="position()"/>
    </xsl:for-each>
    <xsl:call-template name="Newline"></xsl:call-template>
    <xsl:text>;;best case;most likely;worst case;best case;most likely;worst case;</xsl:text>
    <xsl:for-each select="/xmi:XMI/epc:Epc/elements">
      <xsl:text>;</xsl:text>
    </xsl:for-each>
    <xsl:call-template name="Newline"></xsl:call-template>
    <xsl:for-each select="/xmi:XMI/epc:Epc/elements">
      <xsl:call-template name="csv"/>
    </xsl:for-each>  
  </xsl:template>
  
  <xsl:template name="csv" >
    <xsl:value-of select="position()"/>
    <xsl:text>;</xsl:text>
    <xsl:variable name="pos" select ="position()"/>
    <xsl:value-of select="$name_array[$pos]"/>
    <xsl:text>;</xsl:text>
    
    <xsl:call-template name="front">
      <xsl:with-param name="pos" select="position()"></xsl:with-param>
    </xsl:call-template>
    
    <xsl:text>Bearbeitungsbeginn</xsl:text>
    <xsl:variable name="pos1" select="position()"></xsl:variable>
    <xsl:call-template name="bearb">
      <xsl:with-param name="pos" select="$pos1"></xsl:with-param>
    </xsl:call-template>
    <xsl:call-template name="Newline"/>
    <xsl:text>;;;;;;;;Iterationswahrscheinlichkeit</xsl:text>

    <xsl:call-template name="iteration">
    </xsl:call-template>
    <xsl:call-template name="Newline"/>
    <xsl:text>;;;;;;;;Mehrarbeit</xsl:text>
    
    <xsl:call-template name="abn.iter">
    </xsl:call-template>
    <xsl:call-template name="Newline"/>
    <xsl:text>;;;;;;;;Abnahme der Iterationswahrscheinlichkeit</xsl:text>
    <xsl:variable name="pos3" select="position()"></xsl:variable>
    <xsl:call-template name="mehr">
      <xsl:with-param name="pos" select="$pos3"></xsl:with-param>
    </xsl:call-template>
      <xsl:call-template name="Newline"/>
    
  </xsl:template>


  <xsl:template name="bearb">
    <xsl:variable name="id1" select="@xmi:id"/>
    <xsl:call-template name="row1">
      <xsl:with-param name="el1id" select="$id1"/>
    </xsl:call-template>
  </xsl:template>

  <xsl:template name="row1">
    <xsl:param name="el1id"/>
    
    <xsl:for-each select="/xmi:XMI/epc:Epc/elements">
      <xsl:variable name="el2id" select="@xmi:id"/>
      <xsl:text>;</xsl:text>
      <xsl:for-each select="key('to_key',$el1id)">
        <xsl:variable name="id1" select="@xmi:id"/>
        <xsl:for-each select="key('from_key',$el2id)">
          <xsl:variable name="id2" select="@xmi:id"/>
          <xsl:if test="$id1=$id2">
            <xsl:for-each select="key('name_key','Bearbeitungsbeginn')">
              <xsl:variable name="val" select="@value"/>
              <xsl:variable name="cid" select="@id"/>
              <xsl:if test="$id1=$cid">
                <xsl:value-of select="$val"/>
              </xsl:if>
            </xsl:for-each>
          </xsl:if>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="iteration">
    <xsl:variable name="id1" select="@xmi:id"/>
    <xsl:call-template name="row2">
      <xsl:with-param name="el1id" select="$id1"/>
    </xsl:call-template>
  </xsl:template>

  <xsl:template name="abn.iter">
    <xsl:variable name="id1" select="@xmi:id"/>
    <xsl:call-template name="row3">
      <xsl:with-param name="el1id" select="$id1"/>
    </xsl:call-template>
  </xsl:template>

  <xsl:template name="mehr">
    <xsl:variable name="id1" select="@xmi:id"/>
    <xsl:call-template name="row4">
      <xsl:with-param name="el1id" select="$id1"/>
    </xsl:call-template>
    
  </xsl:template>
  <xsl:template name="Newline">
    <xsl:text>&#xD;&#xA;</xsl:text>
  </xsl:template>

  <xsl:template name="front">
    <xsl:param name="pos"></xsl:param>
    <xsl:for-each select="key('name_key','zeit_best')">
      <xsl:variable name="pos1" select="$pos"></xsl:variable>
      <xsl:variable name="a_id" select="@id"></xsl:variable>
	  <!--<xsl:variable name="wert" select="@text"></xsl:variable>-->
	  <xsl:variable name="wert" select="@value" />
      <xsl:choose>
        <xsl:when test="contains($id_param[$pos1],$a_id)">
          <xsl:value-of select="$wert"/>
          <xsl:text>;</xsl:text>
        </xsl:when>
      </xsl:choose>
    </xsl:for-each>
    <xsl:for-each select="key('name_key','zeit_avg')">
      <xsl:variable name="pos1" select="$pos"></xsl:variable>
      <xsl:variable name="a_id" select="@id"></xsl:variable>
      <!--<xsl:variable name="wert" select="@text"></xsl:variable>-->
      <xsl:variable name="wert" select="@value" />
      <xsl:choose>
        <xsl:when test="contains($id_param[$pos1],$a_id)">
          <xsl:value-of select="$wert"/>
          <xsl:text>;</xsl:text>
        </xsl:when>
      </xsl:choose>
    </xsl:for-each>
    <xsl:for-each select="key('name_key','zeit_worst')">
      <xsl:variable name="pos1" select="$pos"></xsl:variable>
      <xsl:variable name="a_id" select="@id"></xsl:variable>
      <!--<xsl:variable name="wert" select="@text"></xsl:variable>-->
      <xsl:variable name="wert" select="@value" />
      <xsl:choose>
        <xsl:when test="contains($id_param[$pos1],$a_id)">
          <xsl:value-of select="$wert"/>
          <xsl:text>;</xsl:text>
        </xsl:when>
      </xsl:choose>
    </xsl:for-each>
    <xsl:for-each select="key('name_key','kosten_best')">
      <xsl:variable name="pos1" select="$pos"></xsl:variable>
      <xsl:variable name="a_id" select="@id"></xsl:variable>
      <!--<xsl:variable name="wert" select="@text"></xsl:variable>-->
      <xsl:variable name="wert" select="@value" />
      <xsl:choose>
        <xsl:when test="contains($id_param[$pos1],$a_id)">
          <xsl:value-of select="$wert"/>
          <xsl:text>;</xsl:text>
        </xsl:when>
      </xsl:choose>
    </xsl:for-each>
    <xsl:for-each select="key('name_key','kosten_avg')">
      <xsl:variable name="pos1" select="$pos"></xsl:variable>
      <xsl:variable name="a_id" select="@id"></xsl:variable>
      <!--<xsl:variable name="wert" select="@text"></xsl:variable>-->
      <xsl:variable name="wert" select="@value" />
      <xsl:choose>
        <xsl:when test="contains($id_param[$pos1],$a_id)">
          <xsl:value-of select="$wert"/>
          <xsl:text>;</xsl:text>
        </xsl:when>
      </xsl:choose>
    </xsl:for-each>

    <xsl:for-each select="key('name_key','kosten_worst')">
      <xsl:variable name="pos1" select="$pos"></xsl:variable>
      <xsl:variable name="a_id" select="@id"></xsl:variable>
      <!--<xsl:variable name="wert" select="@text"></xsl:variable>-->
      <xsl:variable name="wert" select="@value" />
      <xsl:choose>
        <xsl:when test="contains($id_param[$pos1],$a_id)">
          <xsl:value-of select="$wert"/>
          <xsl:text>;</xsl:text>
        </xsl:when>
      </xsl:choose>
    </xsl:for-each>
  </xsl:template>
  
  <xsl:template name="row2">
    <xsl:param name="el1id"/>

    <xsl:for-each select="/xmi:XMI/epc:Epc/elements">
      <xsl:variable name="el2id" select="@xmi:id"/>
      <xsl:text>;</xsl:text>
      <xsl:for-each select="key('to_key',$el1id)">
        <xsl:variable name="id1" select="@xmi:id"/>
        <xsl:for-each select="key('from_key',$el2id)">
          <xsl:variable name="id2" select="@xmi:id"/>
          <xsl:if test="$id1=$id2">
            <xsl:for-each select="key('name_key','Iterationswahrscheinlichkeit')">
              <xsl:variable name="val" select="@value"/>
              <xsl:variable name="cid" select="@id"/>
              <xsl:if test="$id1=$cid">
                <xsl:value-of select="$val"/>
              </xsl:if>
            </xsl:for-each>
          </xsl:if>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:template>
  
  <xsl:template name="row3">
    <xsl:param name="el1id"/>

    <xsl:for-each select="/xmi:XMI/epc:Epc/elements">
      <xsl:variable name="el2id" select="@xmi:id"/>
      <xsl:text>;</xsl:text>
      <xsl:for-each select="key('to_key',$el1id)">
        <xsl:variable name="id1" select="@xmi:id"/>
        <xsl:for-each select="key('from_key',$el2id)">
          <xsl:variable name="id2" select="@xmi:id"/>
          <xsl:if test="$id1=$id2">
            <xsl:for-each select="key('name_key','Mehrarbeit')">
              <xsl:variable name="val" select="@value"/>
              <xsl:variable name="cid" select="@id"/>
              <xsl:if test="$id1=$cid">
                <xsl:value-of select="$val"/>
              </xsl:if>
            </xsl:for-each>
          </xsl:if>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:template>
  
  <xsl:template name="row4">
    <xsl:param name="el1id"/>

    <xsl:for-each select="/xmi:XMI/epc:Epc/elements">
      <xsl:variable name="el2pos" select="position()"/>
      <xsl:variable name="el2id" select="@xmi:id"/>
      <xsl:text>;</xsl:text>
      <xsl:for-each select="key('to_key',$el1id)">
        <xsl:variable name="id1" select="@xmi:id"/>
        <xsl:for-each select="key('from_key',$el2id)">
          <xsl:variable name="id2" select="@xmi:id"/>
          <xsl:if test="$id1=$id2">
            <xsl:for-each select="key('name_key','AbnIterationswahrscheinlichkeit')">
              <xsl:variable name="val" select="@value"/>
              <xsl:variable name="cid" select="@id"/>
              <xsl:if test="$id1=$cid">
                <xsl:value-of select="$val"/>
              </xsl:if>
            </xsl:for-each>
          </xsl:if>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>

